package org.eco.als.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.eco.als.domain.bo.CarryChecklistBo;
import org.eco.als.domain.vo.CarryChecklistImportVo;
import org.eco.als.domain.vo.CarryChecklistVo;
import org.eco.als.service.ICarryChecklistService;
import org.eco.common.core.core.domain.model.LoginUser;
import org.eco.common.core.utils.SpringUtils;
import org.eco.common.core.utils.ValidatorUtils;
import org.eco.common.excel.core.ExcelListener;
import org.eco.common.excel.core.ExcelResult;
import org.eco.common.excel.entity.ExcelResultRes;

import java.util.List;

/**
 * 任务携行自定义导入
 *
 * @author wgk
 */
@Slf4j
public class CarryChecklistImportListener extends AnalysisEventListener<CarryChecklistImportVo> implements ExcelListener<CarryChecklistImportVo> {
    private final ICarryChecklistService carryChecklistService;

    private final Boolean isUpdateSupport;
    private final LoginUser loginUser;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();
    private int successNum = 0;
    private int failureNum = 0;

    public CarryChecklistImportListener(Boolean isUpdateSupport, LoginUser loginUser) {
        this.carryChecklistService = SpringUtils.getBean(ICarryChecklistService.class);
        this.isUpdateSupport = isUpdateSupport;
        this.loginUser = loginUser;
    }

    @Override
    public void invoke(CarryChecklistImportVo carryChecklistVo, AnalysisContext context) {
        try {

            CarryChecklistBo carryChecklistBo = BeanUtil.toBean(carryChecklistVo, CarryChecklistBo.class);

            //TODO:根据某个字段，查询数据库表中是否存在记录，不存在就新增，存在就更新
            CarryChecklistVo carryChecklistVo1 = null;

            //carryChecklistVo1 = carryChecklistService.selectBySomefield(carryChecklistVo.getSomefield());
            if (ObjectUtil.isNull(carryChecklistVo1)) {
                //不存在就新增
                setBo(carryChecklistBo);
                ValidatorUtils.validate(carryChecklistBo);
                boolean inserted = carryChecklistService.insert(carryChecklistBo);

                if (inserted) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、任务携行 记录导入成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、任务携行 记录导入失败");
                }
            } else if (isUpdateSupport) {
                //存在就更新
                carryChecklistBo.setId(carryChecklistVo1.getId());//主键
                carryChecklistBo.setVersion(carryChecklistVo1.getVersion());
                boolean updated = carryChecklistService.update(carryChecklistBo);
                if (updated) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、任务携行 记录更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、任务携行 记录更新失败");
                }
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、任务携行 记录导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    private void setBo(CarryChecklistBo carryChecklistBo) {
        carryChecklistBo.setVersion(0);
        carryChecklistBo.setCreateBy(loginUser.getUserId());
        carryChecklistBo.setUpdateBy(loginUser.getUserId());
        carryChecklistBo.setTenantId(loginUser.getTenantId());
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        log.info("解析完成");
    }

    @Override
    public ExcelResult<CarryChecklistImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public ExcelResultRes getAnalysis() {
                if (failureNum > 0 && successNum == 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    return ExcelResultRes.builder().logInfo(failureMsg.toString()).status("0").build();
                } else if (failureNum > 0 && successNum > 0) {
                    failureMsg.insert(0, "很抱歉，部分导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    return ExcelResultRes.builder().logInfo(failureMsg.toString()).status("2").build();
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                    return ExcelResultRes.builder().logInfo(successMsg.toString()).status("1").build();
                }
            }

            @Override
            public List<CarryChecklistImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
